//
//  ViewController.m
//  TextViewDemo
//
//  Created by user on 16/10/18.
//  Copyright © 2016年 IWALL. All rights reserved.
//

#import "ViewController.h"
#import "EMTextView.h"

@interface ViewController ()<UITextViewDelegate>

@property(nonatomic, strong)EMTextView *contextView;

@property(nonatomic, assign)CGFloat keyBoardHeight;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    self.contextView = [[EMTextView alloc]init];
    self.contextView.scrollEnabled = YES;
    self.contextView.delegate = self;
    self.contextView.layoutManager.allowsNonContiguousLayout = NO;
    self.contextView.placeholder = @"写点什么吧。。。";
    self.contextView.layer.borderWidth = 0.5;
    self.contextView.layer.borderColor = [UIColor grayColor].CGColor;
    self.contextView.layer.cornerRadius = 10;
    self.contextView.font = [UIFont systemFontOfSize:17];

    [self.view addSubview:self.contextView];
    
    self.contextView.frame = CGRectMake(20, 300, [UIScreen mainScreen].bounds.size.width - 40, [UIScreen mainScreen].bounds.size.height - 300);
    //数据框记录键盘弹出高度
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillShow:)
                                                 name:UIKeyboardWillShowNotification object:nil];
}
#pragma mark - UIKeyBoardNotification
- (void)keyboardWillShow:(NSNotification *)notification
{
    NSDictionary *dic   = [notification userInfo];
    NSValue *aValue     = [dic objectForKey:UIKeyboardFrameEndUserInfoKey];
    CGRect keyboardRect = [aValue CGRectValue];
    float height        = keyboardRect.size.height;//键盘的高度
    self.keyBoardHeight = height;
    NSLog(@"%f",self.keyBoardHeight);
    [self textViewContent:self.contextView];

}

#pragma mark - UITextViewDelegate
- (void)textViewDidChange:(UITextView *)textView
{
    [self textViewContent:textView];
}

//计算
- (void)textViewContent:(UITextView *)textView
{
    CGFloat floatValue = [self heightForString:textView andWidth:[UIScreen mainScreen].bounds.size.width - 40];
    NSLog(@"***********%f",floatValue); //字体到138的时候就要进行换行
    CGFloat showHeight = [UIScreen mainScreen].bounds.size.height - textView.frame.origin.y - self.keyBoardHeight;
    NSLog(@"-----------%f",showHeight);
    if (floatValue > showHeight) {
        [UIView animateWithDuration:0.2 animations:^{
            self.contextView.contentInset = UIEdgeInsetsMake(- (floatValue - showHeight), 0.f, 0.f, 0.f);
        }];
    }

}


- (float) heightForString:(UITextView *)textView andWidth:(float)width{
    CGSize sizeToFit = [textView sizeThatFits:CGSizeMake(width, MAXFLOAT)];
    return sizeToFit.height;
}


- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
    [UIView animateWithDuration:0.2 animations:^{
        self.contextView.contentInset = UIEdgeInsetsMake(0.f, 0.f, 0.f, 0.f);
    }];
    [self.view endEditing:YES];
}

@end
